/********************************************************************
*********************************************************************
*	Processor	: PIC18F2550
*	FileName	: PIC18fTimer.h
*	Dependencies: header file
*
*	History:
*	Date		Designer	Description
*	07/23/2010	DachsTulip	Created	
*
*	Copyright (c) 2010 by DachsTulip
*********************************************************************
********************************************************************/
#ifndef __pic18fTimer__
	#define __pic18fTimer__

/**
	C:\Program Files\Microchip\MCC18\h\GenericTypeDefs.h
				|-> typedef unsigned char       UINT8; etc
	*/
#include "GenericTypeDefs.h"

/**
***********************************************************************
* Definition
************************************************************************
*/
#define		TM05MSEC	(UINT16)5				//  5msec timer
#define		TM10MSEC	(UINT16)10				// 10msec timer
#define		TM40MSEC	(UINT16)40				// 40msec timer
#define		TM100MSEC	(UINT16)100				// 100msec timer
#define		TM50SEC		(UINT16)5000			// 5.0sec timer


/**
***********************************************************************
* Function Declaration
************************************************************************
*/
extern BOOL timer1_UpFlag;
extern BOOL timer3_UpFlag;

extern void timer_config(UINT8);
extern BOOL timer_RepeatSet(UINT8);
extern void msecTimer1_Start(UINT16);
extern void msecTimer1_Stop(void);
extern void msecTimer3_Stop(void);

#endif		/* __pic18fTimer__ */
/* end of PIC18fTimer.h */
