/**********************************************************************
***********************************************************************
*	Processor	: PIC18F2550
*	File Name   : PatternData.c
*	Summary		: L[E}EXR[hEEPROMɓǂݏ
*
*	History:
*	Date		Designer	Description
*	07/23/2010	DachsTulip	Created	
*
*	Copyright (c) 2010 by DachsTulip
***********************************************************************
***********************************************************************/

/**
***********************************************************************
	Cu\[XEwb_[
C:\Program Files\Microchip\MCC18\h\p18cxxx.h
		|-> #include <p18f2550.h>
	C:\Program Files\Microchip\MCC18\h\p18f2550.h

C:\Program Files\Microchip\MCC18\src\pmc_common\i2c

C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_eesr.c
	unsigned char EESequentialRead( unsigned char control, unsigned char address, unsigned char *rdptr, unsigned char length )

C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_eerr.c
	unsigned int EERandomRead( unsigned char control, unsigned char address )
C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_gets.c
	unsigned char getsI2C( unsigned char *rdptr, unsigned char length )

	unsigned int EECurrentAddRead( unsigned char control )
			return with contents of SSPBUF

	unsigned char EEAckPolling( unsigned char control )
C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_eepw.c
	unsigned char EEPageWrite( unsigned char control, unsigned char address, unsigned char *wrptr )
C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_eebw.c
	unsigned char EEByteWrite( unsigned char control, unsigned char address, unsigned char data )
C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_writ.c
	MasterWriteI2C()

************************************************************************
*/

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#include	<ctype.h>
/**
	C:\Program Files\Microchip\MCC18\h\delays.h
		|-> Delay10TCYx()
		|-> Delay100TCYx()
		|-> Delay1KTCYx()
		|-> Delay10KTCYx()
	*/
#include	<delays.h>
/**
	C:\Program Files\Microchip\MCC18\h\i2c.h
			|-> #include "pconfig.h"
	*/
#include	<i2c.h>

#include "HardwareProfile.h"
#include	"PatternData.h"
//				|-> #include	"mouseKey.h"
#include	"PrintSCI.h"
//				|-> #include	"picSio.h"

/**
***********************************************************************
* Structure
************************************************************************
*/
typedef enum
{
	 ADDPATTERN_RUN = 0
	,ADDPATTERN_END

} AadPattern_t;

/**
***********************************************************************
* debug Definition
************************************************************************
	*/
 #define _ERROR_PRINTF_
#if defined(_ERROR_PRINTF_)
	#if defined(__SIO_ENABLE__)
		#define ERROR_PRINTF(__dbg) __dbg
	#else
		#define ERROR_PRINTF(__dbg)
	#endif
#else
	#define ERROR_PRINTF(__dbg)
#endif

// #define _DEBUG_PRINTF_
#if defined(_DEBUG_PRINTF_)
	#if defined(__SIO_ENABLE__)
		#define DEBUG_PRINTF(__dbg) __dbg
	#else
		#define DEBUG_PRINTF(__dbg)
	#endif
#else
	#define DEBUG_PRINTF(__dbg)
#endif

// #define _TEST_PRINTF_
#if defined(_TEST_PRINTF_)
	#if defined(__SIO_ENABLE__)
		#define TEST_PRINTF(__dbg) __dbg
	#else
		#define TEST_PRINTF(__dbg)
	#endif
#else
	#define TEST_PRINTF(__dbg)
#endif

/**
***********************************************************************
* Definition
************************************************************************
	*/

/**
****************************************************************************
 * :        
	C:\Program Files\Microchip\MCC18\h\pconfig.h
			|-> #define I2C_V1

	C:\Program Files\Microchip\MCC18\h\i2c.h
		|-> #define StartI2C()  SSPCON2bits.SEN=1;while(SSPCON2bits.SEN)
	
	C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_open.c
			  SSPCON1 |= sync_mode;    // select serial mode 
			  			MSSP CONTROL REGISTER 1 (SPI MODE)
			  SSPCON2
			  			MSSP CONTROL REGISTER 2 (I2C MASTER MODE)
			  SSPSTAT |= slew;         // slew rate on/off 
						MSSP STATUS REGISTER (I2C MODE)
		http://www.picfun.com/pic18/mod18x12.html
		SSPCON2WX^I2C[hł̂ݎg
		
		void StartI2C( void )
				SSPCON2bits.SEN = 1;            // initiate bus start condition
		void RestartI2C( void )
				SSPCON2bits.RSEN = 1;           // initiate bus restart condition
		C:\Program Files\Microchip\MCC18\h\i2c.h
			#define StopI2C()  SSPCON2bits.PEN=1;while(SSPCON2bits.PEN)
		void CloseI2C( void )
 ****************************************************************************
	*/
/**
	SSPCON1
		bit 5 SSPEN: Master Synchronous Serial Port Enable bit
		bit 3-0 SSPM3:SSPM0: Master Synchronous Serial Port Mode Select bits
			1000 = I2C Master mode, clock = FOSC/(4 * (SSPADD + 1))(2,3)
	SSPCON2
		bit 6 ACKSTAT: Acknowledge Status bit (Master Transmit mode only)
			0 = Acknowledge was received from slave
		bit 4 ACKEN: Acknowledge Sequence Enable bit(2)
			1 = Initiate Acknowledge sequence on SDA and SCL pins and transmit ACKDT data bit. Automatically
				cleared by hardware.
			0 = Acknowledge sequence Idle
		bit 3 RCEN: Receive Enable bit (Master Receive mode only)(2)
			1 = Enables Receive mode for I2C
		bit 2 PEN: Stop Condition Enable bit(2)
			1 = Initiate Stop condition on SDA and SCL pins. Automatically cleared by hardware.
		bit 0 SEN: Start Condition Enable/Stretch Enable bit(2)
			1 = Initiate Start condition on SDA and SCL pins. Automatically cleared by hardware.
	SSPSTAT
		bit 2 R/W: Read/Write Information bit (Used in I2C mode only.)

	*/

void ioIdleI2C_BclifClear( void )
{
/**
	SSPCON2: MSSP CONTROL REGISTER 2 (I2Ctm MASTER MODE)
		bit 7 GCEN: General Call Enable bit (Slave mode only)
				Unused in Master mode.
		bit 6 ACKSTAT: Acknowledge Status bit (Master Transmit mode only)
				1 = Acknowledge was not received from slave
				0 = Acknowledge was received from slave
		bit 5 ACKDT: Acknowledge Data bit (Master Receive mode only)(1)
				1 = Not Acknowledge
				0 = Acknowledge
		bit 4 ACKEN: Acknowledge Sequence Enable bit(2)
				1 = Initiate Acknowledge sequence on SDA and SCL pins and transmit ACKDT data bit. Automatically
					cleared by hardware.
				0 = Acknowledge sequence Idle
		bit 3 RCEN: Receive Enable bit (Master Receive mode only)(2)
				1 = Enables Receive mode for I2C
				0 = Receive Idle
		bit 2 PEN: Stop Condition Enable bit(2)
				1 = Initiate Stop condition on SDA and SCL pins. Automatically cleared by hardware.
				0 = Stop condition Idle
		bit 1 RSEN: Repeated Start Condition Enable bit(2)
				1 = Initiate Repeated Start condition on SDA and SCL pins. Automatically cleared by hardware.
				0 = Repeated Start condition Idle
		bit 0 SEN: Start Condition Enable/Stretch Enable bit(2)
				1 = Initiate Start condition on SDA and SCL pins. Automatically cleared by hardware.
				0 = Start condition Idle

	SSPSTAT: MSSP STATUS REGISTER (SPI MODE)
		bit 2 R/W: Read/Write Information bit
			Used in I2C mode only.
	*/
  while ( ( SSPCON2 & 0x1F ) || ( SSPSTATbits.R_W ) )
  {
     continue;
  }
/**
	PIR2: PERIPHERAL INTERRUPT REQUEST (FLAG) REGISTER 2
		bit 3 BCLIF: Bus Collision Interrupt Flag bit
			1 = A bus collision has occurred (must be cleared in software)
			0 = No bus collision occurred
	*/
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("err bclif\r\n"), 0, 0);)
	PIR2bits.BCLIF=0;
  }
}


UINT8 MasterWriteI2C(UINT8 data_out )
{
  SSPBUF = data_out;           // write single byte to SSPBUF

  if ( SSPCON1bits.WCOL )      // test if write collision occurred
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );              // if WCOL bit is set return negative #
  }

  if( ((SSPCON1&0x0F)==0x08) || ((SSPCON1&0x0F)==0x0B) )    //master mode only
  {
    while( SSPSTATbits.BF );   // wait until write cycle is complete   
    IdleI2C();                 // ensure module is idle
    if ( SSPCON2bits.ACKSTAT ) // test for ACK condition received
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
       return ( -2 );          // return NACK
    }
    return ( 0 );             //return ACK
  }
}

/**
	Control Byte send
		Retrying of three times
	*/
Emulate_Error_t EepRomControlWrite(void)
{
	UINT8 retryCnt=3;
    goto begin;

    do{
      /**
          EEPROM ݎԑ҂Ԓx
          Write cycle time  4msec(24XX00)
          Delay100TCYx(100)=2.5msec
         */
      Delay100TCYx(120);            // 3msec delay()
      IdleI2C();                      // ensure module is idle
      StartI2C();                     // initiate START condition

begin:
      if(MasterWriteI2C(EEPROM_WRITE_CONTROL_CODE)==0)      // write byte - R/W bit should be 0
      {
            return (EMU_CALL_OK);
      }
      ERROR_PRINTF(PrintSCI((ROM BYTE *)("retry=%x\r\n"), (UINT16)(4-retryCnt), 0);)
      StopI2C(); 

    }while(--retryCnt);

	ERROR_PRINTF(PrintSCI((ROM BYTE *)("Err 3retry\r\n"), 0, 0);)
    return (EMU_CALL_RETRY);      // set error for write collision
}

/**
	2010/05/28() Note : MicrochipłC  address݂hight/Low łQ񂠂 
	*/
UINT8 ioEERandomRead( UINT16 address )
{

  ioIdleI2C_BclifClear();                      // ensure module is idle
  StartI2C();                     // initiate START condition

  while ( SSPCON2bits.SEN );      // wait until start condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  else
  {
    if(EepRomControlWrite() != EMU_CALL_OK)    // write byte - R/W bit should be 0
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );              // return with write collision error
    }

    if ( MasterWriteI2C((UINT8)(address>>8)))  // WRITE word hight address for EEPROM
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // return with write collision error
    }
    if ( MasterWriteI2C((UINT8)(address) ) )  // WRITE word low address for EEPROM
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // return with write collision error
    }

    RestartI2C();             // generate I2C bus restart condition
    while ( SSPCON2bits.RSEN );// wait until re-start condition is over 
    if ( PIR2bits.BCLIF )     // test for bus collision
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -1 );          // return with Bus Collision error 
    }
                      
    if ( MasterWriteI2C(EEPROM_READ_CONTROL_CODE))// write 1 byte - R/W bit should be 1
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );          // return with write collision error
    }

    {
      SSPCON2bits.RCEN = 1;       // enable master for 1 byte reception
      while ( SSPCON2bits.RCEN ); // check that receive sequence is over
      NotAckI2C();              // send ACK condition
      while ( SSPCON2bits.ACKEN ); // wait until ACK sequence is over 
      StopI2C();              // send STOP condition
      while ( SSPCON2bits.PEN ); // wait until stop condition is over 
      if ( PIR2bits.BCLIF )   // test for bus collision
      {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
       return ( -1 );         // return with Bus Collision error 
      }
    }
  }
  return ( (unsigned int) SSPBUF );     // return with data
}

UINT8 ioEECountsRead( UINT16 address, UINT8 *rdptr, UINT8 length )
{
  ioIdleI2C_BclifClear();                      // ensure module is idle
  StartI2C();                     // initiate START condition
  while ( SSPCON2bits.SEN );      // wait until start condition is over 
  if ( PIR2bits.BCLIF )           // test for Bus Collision(Փ) Interrupt Flag bit
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  else
  {
    if(EepRomControlWrite() != EMU_CALL_OK)    // write byte - R/W bit should be 0
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );              // set error for write collision
    }

    {
      if ( MasterWriteI2C((UINT8)(address>>8)))  // WRITE word hight address for EEPROM
      {
	    StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
        return ( -3 );            // return with write collision error
      }
      if ( MasterWriteI2C((UINT8)(address) ) )  // WRITE word low address for EEPROM
      {
	    StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
        return ( -3 );            // return with write collision error
      }
 
      {
        RestartI2C();             // generate I2C bus restart condition
        while ( SSPCON2bits.RSEN );  // wait until re-start condition is over 
        if ( MasterWriteI2C(EEPROM_READ_CONTROL_CODE))// WRITE 1 byte - R/W bit should be 1 for read
        {
		  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
          return ( -3 );          // set error for write collision
        }
      
        {
          /**
                  C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_gets.c
              */
          if ( getsI2C( rdptr, length ) )// read in multiple bytes
          {
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
		    return ( -1 );        // return with Bus Collision error
          }

          NotAckI2C();            // send not ACK condition
          while ( SSPCON2bits.ACKEN );// wait until ACK sequence is over 
          StopI2C();              // send STOP condition
          while ( SSPCON2bits.PEN );// wait until stop condition is over 
          if ( PIR2bits.BCLIF )   // test for bus collision
          {
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
            return ( -1 );        // return with Bus Collision error 
          }
        }
      }
    }
  }
  return ( 0 );                   // return with no error
}


/**
	2010/05/28() Note : MicrochipłC  address݂hight/Low łQ񂠂 
	Note : 24LC64EEPROḾAA݂page(max32Byte)܂鏑݂͕s
            8421 8421 8421 8421
            **** **** **1* ****   **2*h𒴂ƃ_
	*/
UINT8 ioEEByteWrite( UINT16 address, UINT8 cnt , UINT8 data )
{
  ioIdleI2C_BclifClear();                      // ensure module is idle
  StartI2C();                     // initiate START condition
  while ( SSPCON2bits.SEN );      // wait until start condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  else                            // start condition successful
  {
    if(EepRomControlWrite() != EMU_CALL_OK)    // write byte - R/W bit should be 0
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );              // set error for write collision
    }

    { 
      if ( MasterWriteI2C((UINT8)(address>>8) ) )  // WRITE word hight address for EEPROM
      {
	    StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
        return ( -3 );            // set error for write collision
      }
      if ( MasterWriteI2C((UINT8)(address) ) )  // WRITE word low address for EEPROM
      {
	    StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
        return ( -3 );            // set error for write collision
      }

      { 
        UINT8	i;
        if(cnt>EEPROM_PAGE_MAX)
        {
			cnt=EEPROM_PAGE_MAX;
		}
        for(i=0; i<cnt; i++)
        {
          if ( MasterWriteI2C( data ) )   // data byte for EEPROM
          {
		    StopI2C(); 
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
            return ( -3 );          // set error for write collision
          }
        }
      }
    }
  }

  //IdleI2C();                      // ensure module is idle  
  StopI2C();                      // send STOP condition
  while ( SSPCON2bits.PEN );      // wait until stop condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  return ( 0 );                   // return with no error
}

/**
	QByteA
	Note : 24LC64EEPROḾAA݂page(max32Byte)܂鏑݂͕s
			addressl͋łȂpage܂肪댯B
            8421 8421 8421 8421
            **** **** **1* ****   **2*h𒴂ƃ_
	*/
UINT8 ioEEUint16Write( UINT16 address, UINT16 data )
{
  ioIdleI2C_BclifClear();                      // ensure module is idle
  StartI2C();                     // initiate START condition
  while ( SSPCON2bits.SEN );      // wait until start condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  else                            // start condition successful
  {
    if(EepRomControlWrite() != EMU_CALL_OK)    // write byte - R/W bit should be 0
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );              // set error for write collision
    }

    if ( MasterWriteI2C((UINT8)(address>>8) ) )  // WRITE word hight address for EEPROM
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // set error for write collision
    }
    if ( MasterWriteI2C((UINT8)(address) ) )  // WRITE word low address for EEPROM
    {
      StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // set error for write collision
    }

    if ( MasterWriteI2C( (UINT8)data ) )   // data byte for EEPROM
    {
      StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );          // set error for write collision
    }
    if ( MasterWriteI2C( (UINT8)(data>>8) ) )   // data byte for EEPROM
    {
      StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );          // set error for write collision
    }
  }

  //IdleI2C();                      // ensure module is idle  
  StopI2C();                      // send STOP condition
  while ( SSPCON2bits.PEN );      // wait until stop condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  return ( 0 );                   // return with no error
}

/**
	2010/05/28() Note : MicrochipłC  address݂hight/Low łQ񂠂 
	Note : 24LC64EEPROḾAA݂page(max32Byte)܂鏑݂͕s
            8421 8421 8421 8421
            **** **** **1* ****   **2*h𒴂ƃ_(max32Byte (20hȏ))
		16Byte݂ƂȂĂB(ioEECountsWrite()֐gp cnt=16Byteݒ肵ĂB)
	*/
UINT8 ioEECountsWrite( UINT16 address, UINT8 *wrptr, UINT8 cnt)
{
  UINT8 i;

  ioIdleI2C_BclifClear();                      // ensure module is idle
  StartI2C();                     // initiate START condition
  while ( SSPCON2bits.SEN );      // wait until start condition is over 
  if ( PIR2bits.BCLIF )           // test for bus collision
  {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  else
  {
    if(EepRomControlWrite() != EMU_CALL_OK)    // write byte - R/W bit should be 0
    {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );              // return with write collision error
    }

    if ( MasterWriteI2C((UINT8)(address>>8) ) )  // WRITE word hight address for EEPROM
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // return with write collision error
    }
    if ( MasterWriteI2C((UINT8)(address) ) )  // WRITE word low address for EEPROM
    {
	  StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
      return ( -3 );            // set error for write collision
    }

    for(i=0; i<cnt; i++)
    {
      if ( MasterWriteI2C(*wrptr))  // WRITE word data for EEPROM
      {
	    StopI2C(); 
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
        return ( -3 );            // set error for write collision
      }
      wrptr++;
    }

  }

 //IdleI2C();                      // ensure module is idle
  StopI2C();                      // send STOP condition
  while ( SSPCON2bits.PEN );      // wait until stop condition is over 
  if ( PIR2bits.BCLIF )           // test for Bus collision
  {
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("E:%d\r\n"), (UINT16)__LINE__, 0);)
    return ( -1 );                // return with Bus Collision error 
  }
  return ( 0 );                   // return with no error
}


/**
****************************************************************************
 *
 ****************************************************************************
*/
UINT16 writeIndex;
UINT16 readIndex;

/**
	WriteIndexn
	L[E}EXR}ho^()AhXCfbNX
	*/
void ClearWriteIndex(void)
{
	writeIndex = EEPROM_ADDRESS_MIN;		// EEPROM_ADDRESS_MIN=1024
}

void IncrementWriteIndex(void)
{
	writeIndex += EEPROM_DATA_LENGTH;		// EEPROM_DATA_LENGTH=16
}

/**
	ReadIndexn
	L[E}EXR}ho^AhXǂݏoCfbNX
	*/
void ClearReadIndex(void)
{
	readIndex = 0;
}

void NextReadIndex(void)
{
	readIndex = readIndex + (UINT16)EEPROM_DATA_LENGTH;				// EEPROM_DATA_LENGTH=16
}

Emulate_Error_t CheckReadIndex(void)
{
	UINT16 remainder;
	// EEPROM_ADDRESS_MIN=1024		EEPROM_ADDRESS_MAX=(8128-1)		EEPROM_DATA_LENGTH=16
	if((readIndex < EEPROM_ADDRESS_MIN) || (readIndex > (EEPROM_ADDRESS_MAX - EEPROM_DATA_LENGTH)))
	{
		return(EMU_CALL_FAILED);
	}
	// EEPROM_DATA_LENGTH=16 Ŋ؂邩H
	remainder = readIndex % EEPROM_DATA_LENGTH;
	if(remainder)
	{
		return(EMU_CALL_FAILED);
	}

	return(EMU_CALL_OK);
}

/**
	C:\Program Files\Microchip\MCC18\src\pmc_common\i2c\i2c_open.c
			|-> OpenI2C()Ql
	*/
void OpenEEPRom(void)
{
	SSPADD = 0x19;	// 200KHzݒ ̕ȂCPU\B	2010/05/28()14:37:31
					// (SSPADD=0ݒ肾I2C Clock̂Ŗ肩H)
	SSPSTAT &= 0x3F;			// power on state
	SSPCON1 = 0x00;				// power on state
	SSPCON2 = 0x00;				// power on state
	SSPCON1 |= EEPROM_SSPCON1;	// select serial mode
	SSPSTAT |= EEPROM_SSPSTAT;	// slew rate on/off

	I2C_SCL = 1;
	I2C_SDA = 1;
	SSPCON1 |= SSPENB;			// enable synchronous serial port
}

void CloseEEPRom(void)
{
	CloseI2C();
}

Emulate_Error_t CheckEEPRom(void)
{
	if(SSPCON1bits.SSPEN)	return(EMU_CALL_OK);
	return(EMU_CALL_FAILED);
}

/**
****************************************************************************
	1KByte	XCb`Ǘe[u(SAT:switch allocation table) NA
	clear memory (4*16)*4=256byte	SAT=4byte  rotary Dip Switch=16 footSwitch=4
****************************************************************************
	*/
Emulate_Error_t  ClearEEPRomSatData(void)
{
	UINT8	i;
	UINT8	ret;
	for(i=0; i < 8; i++)
	{
		ret = ioEEByteWrite( (UINT16)(i*32), 32, 0x00);
		if(ret != 0)
		{
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("err ClearEEP=%x i=%x\r\n"), (UINT16)ret, (UINT16)i);)
			return(EMU_CALL_FAILED);
		}
	}
	return(EMU_CALL_OK);
}

/**
****************************************************************************
	foot Switch Norotary Dip Switch Ō܂ Table ̐擪AhX擾B
	XCb`Ǘ(SAT:switch allocation table)
			footSW: foot switch no			1 - 4
				digSw : rotary dip switch		0 - 15
****************************************************************************
	*/
UINT16 GetAllocationTableNo( FootSwitch_t footSW, BYTE digSw)
{
	return(((footSW-1) * EEPROM_FOOTSW_INTERVAL) + (digSw * EEPROM_ADDRESS_INFO_INTERVAL));
//							4*16=64									4
}

/**
****************************************************************************
	EEPROM 24LC64 8KByte(64Kb devices)
	1KByte	XCb`Ǘe[u(SAT:switch allocation table)	4ByteP
			2Byte : p[^f[^̐擪AhX
			6Byte : \
			0xFFFF : ݒ̈
	7KByte	p[^f[^̈
****************************************************************************
	*/
Emulate_Error_t SetSwitchAllocationTable( UINT8 *buffer, UINT16 WrIndex)
{
	UINT8 dt;
	UINT8 footNo=1;
	UINT8 dgsw=0;
	UINT8 DecHex=10;
	UINT16 satNo;
	while(1)
	{
		dt=*buffer;
		if((dt == 0x0d) || (dt == 0x0a))
		{
			if((1 <= footNo) && (footNo <= 4) && (dgsw <= 15))
			{
				// OK then next routine
			}
			else
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err footNo=%x dgsw=%x\r\n"), (UINT16)footNo, (UINT16)dgsw);)
				return(EMU_CALL_FAILED);
			}
			satNo = GetAllocationTableNo( footNo, dgsw);
			if(satNo >= (EEPROM_ADDRESS_MIN-2))
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err eepAdd\r\n"), 0, 0);)
				return(EMU_CALL_FAILED);
			}
//			TEST_PRINTF(PrintSCI((ROM BYTE *)("add=%x WrIndex=%x\r\n"), satNo, WrIndex);)
			// QByteA
			// EEPROM_ADDRESS_INFO_INTERVAL=4 ŋlƂȂ̂page܂肪NȂB
			// Note : addressl͋łȂpage܂肪댯B
			// gGfBA(little endian)kʃAhXɃf[^̉ʃoCgul
			ioEEUint16Write( satNo, WrIndex);
			return(EMU_CALL_OK);
		}
		else if(dt == ',')
		{
			footNo=dgsw;
			dgsw=0;
		}
		else if((dt == 'd')||(dt == 'D'))
		{
			DecHex=10;
			dgsw=0;
		}
		else if((dt == 'h')||(dt == 'H'))
		{
			DecHex=16;
			dgsw=0;
		}
		else if((dt >= '0')&&(dt <= '9'))
		{
			dgsw=dgsw * DecHex;
			dgsw=dgsw+(dt-'0');
		}
		else if((dt >= 'a')&&(dt <= 'f'))
		{
			dgsw=dgsw * DecHex;
			dgsw=dgsw+((dt-'a')+10);
		}
		else if((dt >= 'A')&&(dt <= 'F'))
		{
			dgsw=dgsw * DecHex;
			dgsw=dgsw+((dt-'A')+10);
		}
		else
		{
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("err SetSw\r\n"), 0, 0);)
			return(EMU_CALL_FAILED);
		}
		buffer++;
	}
}

/**
****************************************************************************
 *
 ****************************************************************************
*/
Emulate_Error_t CheckPageAdderss( UINT16 address)
{
	UINT16  adr = address & EEPROM_PAGE_ADDRESS_MASK;		// EEPROM_PAGE_ADDRESS_MASK=0x001F
	if((adr == 0) || (adr == EEPROM_DATA_LENGTH))			// EEPROM_DATA_LENGTH=16
	{
		return(EMU_CALL_OK);
	}
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("err adr=%x\r\n"), adr, 0);)
	return(EMU_CALL_FAILED);
}

/**
****************************************************************************
 * R[hOiBufferEEPROMɏݓo^B
 ****************************************************************************
*/
UINT8	AddBufferIndex=0;
// EEPROMݑO OiBuffer		EEPROM_DATA_LENGTH=16
UINT8	AddEEPRomBeforeBuffer[EEPROM_DATA_LENGTH];

Emulate_Error_t writePatternDataToEepRom( void)
{
	UINT8	ret;
	UINT8	i;

	if(writeIndex < EEPROM_ADDRESS_MIN)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err wIndex min=%x\r\n"), writeIndex, 0);)
		return(EMU_CALL_FAILED);
	}
	if(writeIndex >= EEPROM_ADDRESS_MAX)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err wIndex max=%x\r\n"), writeIndex, 0);)
		return(EMU_CALL_FAILED);
	}
	DEBUG_PRINTF(PrintSCI((ROM BYTE *)("add=%x\r\n"), writeIndex, 0);)

	// AddBufferIndex<(EEPROM_DATA_LENGTH-1) ȉȂ"0"		2010/06/07()
	if(AddBufferIndex < EEPROM_DATA_LENGTH)
	{
		for(i=AddBufferIndex; i<EEPROM_DATA_LENGTH; i++)
		{
			AddEEPRomBeforeBuffer[i] = 0;
		}
	}
	TEST_PRINTF(PrintSCI((ROM BYTE *)("wr7=%x\r\n"), (UINT16)AddEEPRomBeforeBuffer[8], 0);)

	if(CheckPageAdderss(writeIndex) != EMU_CALL_OK)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err PageAdderss=%x\r\n"), writeIndex, 0);)
		return(EMU_CALL_FAILED);
	}

	ret = ioEECountsWrite( writeIndex, &AddEEPRomBeforeBuffer[0], EEPROM_DATA_LENGTH);
	if(ret != 0)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err ioEECountsWrite=%x\r\n"), (UINT16)ret, 0);)
		return(EMU_CALL_FAILED);
	}

	IncrementWriteIndex();

	return(EMU_CALL_OK);
}

/**
****************************************************************************
 * R[hEEPROMݑO OiBufferɓo^{́B
 ****************************************************************************
*/
Emulate_Error_t addPatternDataToBuffer( AadPattern_t info, UINT8 data)
{
	if(AddBufferIndex >= EEPROM_DATA_LENGTH)		// EEPROM_DATA_LENGTH=16
	{
//		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err addPDataToBuf=%x\r\n"), (UINT16)AddBufferIndex, 0);)
//		return(EMU_CALL_FAILED);
		// 2010/06/07() ErrorƂX[BEEPROM_DATA_LENGTH ȏ͖
	}
	else
	{
//		TEST_PRINTF(PrintSCI((ROM BYTE *)("index=%x data=%x\r\n"), (UINT16)AddBufferIndex, (UINT16)data);)
		AddEEPRomBeforeBuffer[AddBufferIndex] = data;
		AddBufferIndex++;
	}
	if(info == ADDPATTERN_END)
	{
		return(writePatternDataToEepRom());
	}
	return(EMU_CALL_OK);
}

/**
****************************************************************************
 * R[hEEPROMݑO OiBufferɓo^B
 ****************************************************************************
*/
Emulate_Error_t SetSwitchPattern( UINT8 *buffer)
{
	Emulate_Error_t result;
	UINT8 dt;
	UINT8 wrdt=0;
	UINT8 DecHex=10;			// ݒ 10iň
	while(1)
	{
		dt=*buffer;
		// sRgL"/"΃f[^IƔfB
		if((dt == 0x0d) || (dt == 0x0a) || (dt == '/'))
		{
			result = addPatternDataToBuffer( ADDPATTERN_END, wrdt);
			if(result != EMU_CALL_OK)
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err end=%x\r\n"), (UINT16)result, 0);)
				return(EMU_CALL_FAILED);
			}
			return(EMU_CALL_COMPLET);
		}
		else if(dt == ',')
		{
			result = addPatternDataToBuffer( ADDPATTERN_RUN, wrdt);
			if(result != EMU_CALL_OK)
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err comma=%x\r\n"), (UINT16)result, 0);)
				return(EMU_CALL_FAILED);
			}
			DecHex=10;
			wrdt=0;
		}
		else if((dt == 'd')||(dt == 'D'))
		{
			DecHex=10;
			wrdt=0;
		}
		else if((dt == 'h')||(dt == 'H'))
		{
			DecHex=16;
			wrdt=0;
		}
		else if((dt >= '0')&&(dt <= '9'))
		{
			wrdt=wrdt * DecHex;
			wrdt=wrdt+(dt-'0');
		}
		else if((dt >= 'A')&&(dt <= 'F'))
		{
			wrdt=wrdt * DecHex;
			wrdt=wrdt+((dt-'A')+10);
		}
		else if((dt >= 'a')&&(dt <= 'f'))
		{
			wrdt=wrdt * DecHex;
			wrdt=wrdt+((dt-'a')+10);
		}
		else
		{
			// 悯ȃXy[X^u͖B	2010/06/12(y)
//			ERROR_PRINTF(PrintSCI((ROM BYTE *)("err non=%x\r\n"), (UINT16)result, 0);)
//			return(EMU_CALL_FAILED);
		}
		buffer++;
	}
}


/**
****************************************************************************
 * p\R̃tbgXCb`Ή̃R[hEEPROMɓo^B
 ****************************************************************************
*/
Emulate_Error_t SetHidCodeDataToEEPRom(UINT8 *buffer)
{
	Emulate_Error_t result=EMU_CALL_OK;
	OpenEEPRom();

	switch(*buffer)
	{
		case '$':			// t@C擪R[h
		{
			DEBUG_PRINTF(PrintSCI((ROM BYTE *)("$\r\n"), 0, 0);)
			result = ClearEEPRomSatData();
			if(result != EMU_CALL_OK)
			{
				result=EMU_CALL_FAILED;
				goto exit;
			}
			ClearWriteIndex();
			AddBufferIndex = 0;
			break;
		}
		case '@':			// FootSwitch + Rotary Dip Switch 
		{
			AddBufferIndex = 0;
			DEBUG_PRINTF(PrintSCI((ROM BYTE *)("@=%s\r\n"), (UINT16)(buffer+1), 0);)
			result = SetSwitchAllocationTable((buffer+1), writeIndex);
			if(result != EMU_CALL_OK)
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err@\r\n"), 0, 0);)
				result=EMU_CALL_FAILED;
				goto exit;
			}
			break;
		}
		case 'k':			// key code
		case 'K':			// key code
		case 'm':			// mouse code
		case 'M':			// mouse code
		case 't':			// timers code
		case 'T':			// timers code
		{
			AddBufferIndex = 0;
			result = addPatternDataToBuffer( ADDPATTERN_RUN, *buffer);
			if(result != EMU_CALL_OK)
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err top=%x\r\n"), (UINT16)result, 0);)
				result=EMU_CALL_FAILED;
				goto exit;
			}
			// keyEmousew̎','ŋ؂Ă邩H
			if(*(buffer+1) != ',')
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err comma=%x\r\n"), (UINT16)(*(buffer+1)), 0);)
				result=EMU_CALL_FAILED;
				goto exit;
			}
			// R[hEEPROMݑO OiBufferɓo^B
			result = SetSwitchPattern((buffer+2));
			if(result != EMU_CALL_COMPLET)
			{
				ERROR_PRINTF(PrintSCI((ROM BYTE *)("err data=%x\r\n"), (UINT16)result, 0);)
				result = EMU_CALL_FAILED;
				goto exit;
			}
			result = EMU_CALL_OK;
			break;
		}
		case '/':
		{
			// Rg
			break;
		}
		default:
		{
			result=EMU_CALL_FAILED;
			goto exit;
		}
	}

exit:
	CloseEEPRom();
	return(result);
}

/**
****************************************************************************
	EEPROML̃XCb`Ǘe[u(SAT:switch allocation table)
	L[E}EX̃p^[f[^擾B
	()	XCb`Ǘe[uNop
		footSw			:1-4
		dgsw			:0-15
	ߒl(return value)
		*buffer			:EEPROMLKeyEMousef[^(4Byte)
						'k',0,0,0x58 or 'm',0x01,0,0 or 'k',0xFF,0xFF,0xFF
		Emulate_Error_t	:
****************************************************************************
	*/
extern BYTE DigSW;
Emulate_Error_t GetHidCodeDataFromEEPRom( GetPattData_t patt, FootSwitch_t footSW, UINT8 *buffer)
{
	Emulate_Error_t result;
	UINT16 satNo;
	UINT8 Index[2];
	UINT8 dt;
	UINT8 ret;

	OpenEEPRom();

	if(patt == GET_PATTERN_TOP)
	{
		if((1 <= footSW) && (footSW <= 4) && (DigSW <= 15))
		{
			// OK then next routine
		}
		else
		{
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("err footSW=%x dgsw=%x\r\n"), (UINT16)footSW, (UINT16)DigSW);)
			goto exit;
		}
		satNo = GetAllocationTableNo( footSW, DigSW);
		DEBUG_PRINTF(PrintSCI((ROM BYTE *)("satNo=%x\r\n"), satNo, 0);)
		DEBUG_PRINTF(PrintSCI((ROM BYTE *)("fSW=%x Dig=%x\r\n"), (UINT16)footSW, (UINT16)DigSW);)
		ret=ioEECountsRead( satNo, &Index[0], 2);
		if(ret != 0)
		{
			ERROR_PRINTF(PrintSCI((ROM BYTE *)("err eeRead sat=%x\r\n"), (UINT16)ret, 0);)
			goto exit;
		}
		// R[hf[^i[擪AhX擾=>readIndex
		// Note : (***<<8)ň͂܂Ȃ<<8Index[0]+Index[1]ɍs	2010/06/01()
		readIndex = (UINT16)Index[0] + (((UINT16)(Index[1]))<<8);
	}

	if(CheckReadIndex() != EMU_CALL_OK)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err rdIndex=%x sat=%x\r\n"), readIndex, satNo);)
		result=EMU_CALL_FAILED;
		goto exit;
	}

	// ǏoHIDCODE_BUFFER_ARRAY=10Byte
	// readIndex̊Ǘ16ByteP (24LC64EEPROM̃y[W݂32BytePʂȂ̂ł̔ȒlƂȂĂBj
	ret=ioEECountsRead( readIndex, buffer, HIDCODE_BUFFER_ARRAY);		// HIDCODE_BUFFER_ARRAY=10
	if(ret != 0)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err eeRead buf=%x\r\n"), (UINT16)ret, 0);)
		goto exit;
	}

	NextReadIndex();

	dt=*buffer;
	if((dt == 'k') || (dt == 'K') || (dt == 'm') || (dt == 'M') || (dt == 't') || (dt == 'T'))
	{
		result=EMU_CALL_OK;
		goto exit;
	}

	ERROR_PRINTF(PrintSCI((ROM BYTE *)("err bufTop=%x\r\n"), (UINT16)dt, 0);)
	result=EMU_CALL_FAILED;

exit:
	CloseEEPRom();
	TEST_PRINTF(PrintSCI((ROM BYTE *)("result=%x\r\n"), (UINT16)result, 0);)
	return(result);
}

/**
****************************************************************************
 * Test Program
 ****************************************************************************
*/

// UINT8 tesData = 0x30;	// 2010/05/28() 16:16:04 Ȃɓ삹HH  l0x76ƂȂB

#define DEBUG_WRITE_ADDRESS1		32
#define DEBUG_WRITE_ADDRESS2		52

void testWriteEEPRom(UINT addres)
{
	UINT8	ret;
//                   1234567890123456789
    UINT8 write[20]="123456789ABCDEFGHIJ";

	ret=ioEECountsWrite( addres, write, 20);
	if(ret != 0)
	{
		ERROR_PRINTF(PrintSCI((ROM BYTE *)("err ioEECountsWrite=%x\r\n"), (UINT16)ret, 0);)
		return;
	}
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("wt=%s\r\n"), (UINT16)write, 0);)
}

void testReadEEPRom(UINT addres)
{
	UINT8 read[20];
	read[20]=0;
	read[21]=0;
	ioEECountsRead( addres, &read[0], 20);
	ERROR_PRINTF(PrintSCI((ROM BYTE *)("rd=%s\r\n"), (UINT16)read, 0);)
}

extern BOOL Switch1IsPressed(void);
void testEEPRom(void)
{
	if(Switch1IsPressed() == SWITCH_EDGE_ON)
	{
		OpenEEPRom();
		{
			testWriteEEPRom(DEBUG_WRITE_ADDRESS1);
			testReadEEPRom(DEBUG_WRITE_ADDRESS1);
			testWriteEEPRom(DEBUG_WRITE_ADDRESS2);
			testReadEEPRom(DEBUG_WRITE_ADDRESS2);
		}
		CloseEEPRom();
	}
}


