/**********************************************************************
***********************************************************************
*	Processor	: PIC18F2550
*	File Name	: PrintSCI.c
*	Summary		: printf [(ǂ)
*
*	History:
*	Date		Designer	Description
*	07/23/2010	DachsTulip	Created	
*
*	Copyright (c) 2010 by DachsTulip
***********************************************************************
***********************************************************************/

/**
***********************************************************************
* Includes
************************************************************************
*/
#include	<ctype.h>

#include	"mytype.h"
#include	"PrintSCI.h"
// #include	"picSio.h"
//				|-> #define SCI_BUFF_SIZE  4096
//				|-> #define	SCI_BUFF_SIZE	100		/* 2008/08/28 change DachsTulip */

#if defined(__SIO_ENABLE__)	// VAʐM\[XLɂ`

/**
***********************************************************************
* Definition of debug
************************************************************************
*/

// #define DBG_COMMAND

#ifdef DBG_COMMAND
	#define __DBG_COMMAND(__deb) __deb
#else
	#define __DBG_COMMAND(__deb)
#endif

/**
***********************************************************************
* Definition
* val
* Structure
************************************************************************
*/

#define		DEF_KETA_VALUE		100		/* 傫ȖȒl */
#define		MAX_KETA_VALUE		10

/* ***** definition of enum ****** */
typedef enum
{
	 C_BASE_10 = (UINT16)10
	,C_BASE_16 = (UINT16)16

} CodeBase_t;

typedef enum
{
	 H_BASE_8  = (UINT16)8
	,H_BASE_16 = (UINT16)16
	,H_BASE_32 = (UINT16)32

} HexBase_t;

typedef enum
{
	 HD_LINE_8  = (UINT16)16
	,HD_LINE_16 = (UINT16)8
	,HD_LINE_32 = (UINT16)4

} HexDumpLine_t;

/**
	C:\FootMouseKey\user\picSio.h
				|-> #define		SCI_BUFF_SIZE	40
	*/
UINT8	sio_ring_buffer[SCI_BUFF_SIZE];
UINT16	sio_write_pointer = 0;
UINT16	sio_read_pointer = 0;




/** DECLARATIONS ***************************************************/
#pragma code

/**
***********************************************************************
* SIO Library processing Source
************************************************************************
*/

/**
	ŌCRR[h΂̐폜 ̒v֐
	**Note** 2008/04/24  Mf[^̍ŌCRR[hĂ邩
	2008/10/13 Mf[^buff_p[]GAɃRs[ɁAŌCRR[hRs[Ȃ悤ɂ̂
				̊֐͌_ŕsvƂȂB
	*/
size_t  sio_strlen_cr_deleat( const char *s)
{
	UINT16	length;
	if(s == NULL)	return(0);

	length = strlen( s);
	if(length > 0)
	{
		while(*(s+(length-1)) == '\r')		// ŌオCRR[hH
		{
			if(length > 0)
			{
				length--;
			}
			else
			{
				break;					// while𔲂
			}
		}
	}
	return(length);
}

SINT16 inchxx(void)
{
	SINT16 rxdt;

	if(sci_getc(SCI_CHN0, (UINT8 *)&rxdt) != SIO_CALL_OK)		/*	PM	*/
	{
		rxdt = -1;
	}
	return (rxdt);
}	/* inchxx */

SINT16 inch(void)
{
	SINT16 ch;
	
	ch = inchxx();
	if (islower(ch))
	{
		ch = toupper(ch);			/* 啶ɕϊ܂B */
	}
	return (ch);
}	/* inch */

void outch(UINT8 ch)
{
	while(sci_putc(SCI_CHN0, ch) == SIO_SCI_BUFFER_OVER)	/*	PM	*/
	{
		while(sci_tx_remainderLength() > (SCI_BUFF_SIZE/2));
							/* MsbuffercɂȂ܂ő҂ */
	}
}

void outh(UINT8 xx)
{
	xx &= 0x0f;
	xx |= '0';
	if (xx > '9')
	{
		xx += 7;
	}
	outch(xx);
}	/* outh */

void out2h(UINT8 xx)
{
	outh((UINT8)(xx >> 4));
	outh((UINT8)(xx & 0x0f));
}	/* out2h */

void out4h(UINT16 xx)
{
	out2h((UINT8)(xx >> 8));
	out2h((UINT8)(xx & 0xff));
}	/* out4h */

void out8h(UINT32 xx)
{
	out4h((UINT16)(xx >> 16));
	out4h((UINT16)(xx & 0xffff));
}	/* out8h */

void out6h(UINT32 xx)
{
	out2h((UINT8)((xx >> 16) & 0xff));
	out4h((UINT16)(xx & 0xff));
}	/* out6h */

void crlf(void)
{
	outch(kCRcode);
	outch(kLFcode);
}	/* crlf */

#define		PRINT_BUFF_MAX	100
char	prin_buff[PRINT_BUFF_MAX];			/* WJpobt@(KvȂ瑝₷) */

void PrintSCI_init(void)
{
	int			i;

	for(i=0; i<PRINT_BUFF_MAX;i++)
	{
		prin_buff[i] = 0;
	}
}

void __putchar(char c)
{
//	if (c=='\n') outch('\r');			/* sCR(0x0D)LF(0x0A)  (\n=LF) */
	outch(c);
}

// 񑗐M
void __puts(char *s)
{
	while (*s)
	{
//		if( *s == '\n' ) outch('\r');		/* sCR(0x0D)LF(0x0A) */
		outch(*s);
		s++;
	}
}

void __put_bit(UINT32 dt, HexBase_t base)
{
	char	buf[70];
	UINT16	len = 0;
	UINT32	siftbit = 0x01;
	UINT16	cnt = base;
	buf[sizeof(buf)-1] = '\0';

	if((base == H_BASE_8) || (base == H_BASE_16) || (base == H_BASE_32))
	{
			/* OK root */
	}
	else
	{
		return;
	}

	do{
		if (dt & siftbit)
		{
			buf[sizeof(buf)-2-len] = '1';
		}
		else
		{
			buf[sizeof(buf)-2-len] = '0';
		}
		siftbit = siftbit<<1;
		len++;
		buf[sizeof(buf)-2-len] = ' ';
		len++;
	} while(--cnt);

	__puts(buf+(sizeof(buf)-1-len));
}

// lM HexΉ
void __put_int(UINT32 udt, UINT16 keta, CodeBase_t base)
{
	char	buf[20];
	int		len=0, sgf=0;
	SINT32	sdt = (SINT32)udt;
	UINT32	rem;

	buf[sizeof(buf)-1] = '\0';

	if (keta <= 0) 
	{
		return;
	}

	if ((base == C_BASE_10) || (base == C_BASE_16))
	{
			/* OK root */
	}
	else
	{
		return;
	}

	if((base == C_BASE_10) && (sdt < 0))
	{
		sdt = -sdt;
		sgf=1;
	}

	if (base == C_BASE_10)
	{
		do{
			rem = sdt % base;
			buf[sizeof(buf)-2-len] = rem + '0';
			len++;
			keta--;
		} while((sdt/=base) && (keta));
	}
	else if (base == C_BASE_16)
	{
		do{
			rem = udt % base;
			if (rem < 10){ buf[sizeof(buf)-2-len] = rem + '0'; }
			else		 { buf[sizeof(buf)-2-len] = rem + 'A'- 0xA; }
			len++;
			keta--;
		} while((udt/=base) && (keta));
	}

	if((keta) && (keta < MAX_KETA_VALUE))
	{
		for( ; keta>0; keta--)
		{
			buf[sizeof(buf)-2-len] = '0';
			len++;
		}
	}

/**
		"0x"́AKvȂprintŋLq̎Ał̋Lq́Asvȏꍇ̂Ŏ߂ƂB
		buf[sizeof(buf)-2-len] = 'x';
		len++;
		buf[sizeof(buf)-2-len] = '0';
		len++;
	*/
	if (sgf)
	{
		buf[sizeof(buf)-2-len]='-';
		len++;
	}

	__puts(buf+(sizeof(buf)-1-len));
}

/**
*********************************************************
		PrintSCIo
---------------------------------------------------------
		conversion ̊eľ
		d: 10 i
		D: 10 i
		x: ̕Ȃ16 ii0 ` 9Aa ` fj
		X: 啶̕Ȃ16 ii0 ` 9AA ` Fj
		s: 萔
		S: 萔
		%: 

	sample
	1), PrintSCI(gHello worldh,0,0);
	2), PrintSCI(gdata=%x ddress=%x\n\rh, (UINT16)data, (UINT16)address);
*********************************************************
	*/
#if defined(PIC24F_STARTER_KIT)
void PrintSCI(const char *fmt, UINT32 arg1, UINT32 arg2)
{
	UINT32		uparm;
	SINT32		sparm;

#elif defined(PIC18F2550)
void PrintSCI(ROM BYTE *fmt, UINT16 arg1, UINT16 arg2)
{
	UINT16		uparm;
	SINT16		sparm;
#endif

	UINT16		num  = 0;					// argument index
	UINT16		keta = DEF_KETA_VALUE;		// #define DEF_KETA_VALUE 100

	// Rearranging output strings
	for(; *fmt; fmt++)
	{
		if (*fmt == '%')		// ϊwq^Cvʏ
		{
			fmt++;
				/*  (Q܂) */
			if((*fmt >=  '0') && (*fmt <= '9'))		// PԖڂ̏
			{
				keta = *fmt-'0';
				fmt++;
			}
			if((*fmt >= '0') && (*fmt <= '9'))		// QԖڂ̏
			{
				if(keta <= 9){ keta *= 10; keta += (*fmt-'0'); }
				else		 { keta = (*fmt-'0'); }
				fmt++;
			}
				/* \^Cvʏ */
			switch (*fmt)					// if %, check what type
			{
				case 'b':					// %b, hexadecimal unsigned number
				case 'B':
				{
					if (num == 0)
					{
						uparm = arg1;
					}
					else if (num == 1)
					{
						uparm = arg2;
					}
					else
					{
						break; //ignore > 2 arg
					}
					num++;
					__put_bit(uparm, H_BASE_8);
					break;
				}
				case 'x':					// %x, hexadecimal unsigned number
				case 'X':
				{
					if (num == 0)
					{
						uparm = arg1;
					}
					else if (num == 1)
					{
						uparm = arg2;
					}
					else
					{
						break; //ignore > 2 arg
					}
					num++;
					__put_int(uparm, keta, C_BASE_16);
					break;
				}
				case 'd':					// %d, decimal unsigned number
				case 'D':
				{
					if (num == 0)
					{
						sparm = (SINT32)arg1;
					}
					else if (num == 1)
					{
						sparm = (SINT32)arg2;
					}
					else
					{
						break; //ignore > 2 arg
					}
					num++;
					__put_int((UINT32)sparm, keta, C_BASE_10);
					break;
				}
				case 's':					// %s, a single character
				case 'S':
				{
					char *ch_p;
					if (num==0)
					{
						ch_p = (char *)arg1;
					}
					else if (num == 1)
					{
						ch_p = (char *)arg2;
					}
					else
					{
						break; //ignore > 2 arg
					}
					num++;
					__puts(ch_p);
					break;
				}
				default:
				{
					break;
				}
			}// end switch

			keta = DEF_KETA_VALUE;			/* #define DEF_KETA_VALUE 100 */
		}// end if
		else			// 񏈗
		{
			__putchar(*fmt);
		}
	} //end for
}


#else		// #ifdef __SIO_ENABLE__

	// ֐̒`
	#if defined(PIC24F_STARTER_KIT)
		void PrintSCI(const char *fmt, UINT32 arg1, UINT32 arg2){}
	#elif defined(PIC18F2550)
		void PrintSCI(ROM BYTE *fmt, UINT16 arg1, UINT16 arg2){}
	#endif


#endif		// #ifdef __SIO_ENABLE__

