/********************************************************************
*********************************************************************
*	Processor	: PIC18F2550
*	FileName	: mouseKey.h
*	Dependencies: header file
*
*	History:
*	Date		Designer	Description
*	06/22/2010	DachsTulip	Created	
*
*	Copyright (c) 2010 by DachsTulip
*********************************************************************
********************************************************************/
#ifndef __mouseKey__
	#define __mouseKey__

/**
	C:\Program Files\Microchip\MCC18\h\GenericTypeDefs.h
				|-> typedef unsigned char       UINT8; etc
	*/
#include "GenericTypeDefs.h"

/**
***********************************************************************
* Structure
************************************************************************
*/
typedef enum
{
	 EMU_CALL_OK = (UINT8)0
	,EMU_CALL_FAILED
	,EMU_CALL_CANCWL
	,EMU_CALL_COMPLET
//
	,EMU_CALL_SEN			//SEN: Start Condition Enable/Stretch Enable bit(
	,EMU_CALL_ACKSTAT		// ACKSTAT: Acknowledge Status bit (Master Transmit mode only)
	,EMU_CALL_BCLIF			// BCLIF: Bus Collision( Փ,) Interrupt Flag bit
	,EMU_CALL_ACKERROR
	,EMU_CALL_RETRY

} Emulate_Error_t;


/**
*********************************************************************
	Foot Switch
**********************************************************************
	*/
typedef enum
{
	 FOOT_SWITCH_NON = ((UINT8)0)
	,FOOT_SWITCH1 = ((UINT8)1)
	,FOOT_SWITCH2 = ((UINT8)2)
	,FOOT_SWITCH3 = ((UINT8)3)
	,FOOT_SWITCH4 = ((UINT8)4)

} FootSwitch_t;

// FootSw1IsPressed() ߒlenum
typedef enum
{
	 SWITCH_EDGE_ON
	,SWITCH_ALWAYS_ON
	,SWITCH_EDGE_OFF
	,SWITCH_ALWAYS_OFF
	,SWITCH_TIME_UP

} SwitchReturn_t;

typedef enum
{
	 GET_PATTERN_NON
	,GET_PATTERN_TOP
	,GET_PATTERN_NEXT

} GetPattData_t;


#endif		/* __mouseKey__ */
/* end of mouseKey.h */
