/**********************************************************************
***********************************************************************
*	Processor	: PIC18F2550
*	File Name   : sci.c
*	Summary		: VAʐM(RS232C)
*
*	History:
*	Date		Designer	Description
*	07/23/2010	DachsTulip	Created	
*
*	Copyright (c) 2010 by DachsTulip
***********************************************************************
***********************************************************************/

#ifndef __sio_hedder__
	#define __sio_hedder__

// RS232CVAʐMSĂLEɂRpCXCb`
 #define __SIO_ENABLE__

/**
	C:\Program Files\Microchip\MCC18\h\GenericTypeDefs.h
				|-> typedef unsigned char       UINT8; etc
	*/
#include "GenericTypeDefs.h"
/**
	C:\FootMouseKey\system\Include\Compiler.h
		   		|-> #define ROM                 rom
	*/
#include	"Compiler.h"

#include "HardwareProfile.h"

/**
***********************************************************************
* Definition
************************************************************************
*/

#define kCRcode		(0x0d)			/* "\r" */
#define kLFcode		(0x0a)			/* "\n" */


#if defined(PIC24F_STARTER_KIT)
	// #define		SCI_BUFF_SIZE	256
	// #define		SCI_BUFF_SIZE	1024	/* 2008/04/09 change DachsTulip -log lost Ή */
	#define		SCI_BUFF_SIZE	1024		/* 2008/08/28 change DachsTulip */

#elif defined(PIC18F2550)
/**
	#define		SCI_BUFF_SIZE	72		// 2008/08/28 change DachsTulip
	Lݒ肾ƈȉErrorƂȂB
	MPLINK 4.35, Linker
	Error - section '.udata_picSci.o' can not fit the section. Section '.udata_picSci.o' length=0x000000a2
	Errors    : 1
	BUILD FAILED
	*/
	#define		SCI_BUFF_SIZE	40		// 2010/04/21() 16:24:38
#endif


#define		SERIAL_BPS			19200
#define		SERIAL_HIGH_BPS		115200


/**
***********************************************************************
* Structure
************************************************************************
*/

typedef enum
{
	 SIO_CALL_OK
	,SIO_CALL_FAILED
	,SIO_CALL_CANCWL

	,SIO_CALL_CRCODE
	,SIO_CALL_ZERO
	,SIO_CALL_DATA_SET
	,SIO_CALL_NEXT
	,SIO_CALL_DATA_END
	,SIO_CALL_END

	,SIO_ERR_BUSFREE
	,SIO_ERR_TRANSMIT_END
	,SIO_ERR_ACK
	,SIO_ERR_STOP
	,SIO_ERR_RDRF
	,SIO_ERR_BUSY
	,SIO_ERR_TIMEOVER

	,SIO_ERR_FRAMING
	,SIO_ERR_PARITY
	,SIO_ERR_OVER_RUN

	,SIO_SCI_BUFFER_OVER

	,SIO_BIT_ON
	,SIO_BIT_OFF
	,SIO_BIT_KEEP

} Sio_Error_t;


typedef enum
{
	 SCI_CHN0 = 0
	,SCI_CHNEND

} SIO_Channel_t;


typedef struct
{
	UINT16		length;				// c
	UINT16		read;				// ring counter
	UINT16		write;				// ring counter
	UINT8		*buff;

} SIO_FIFO;

typedef struct
{
	BOOL		RunStop;
	BOOL		TxRingOver;

} SIO_Info_t;


/**
***********************************************************************
* ֐`
************************************************************************
*/
#if defined(__SIO_ENABLE__)	// VAʐM\[XLɂ`

	extern void sci_initial(void);
	extern Sio_Error_t  sci_start( SIO_Channel_t, UINT32, UINT8, UINT8, UINT8);
	extern Sio_Error_t  sci_putc(SIO_Channel_t , UINT8);		// Pi[
	extern Sio_Error_t  sci_getc(SIO_Channel_t , UINT8 *);		// P擾
	extern UINT16 sci_tx_remainderLength(void);

	extern void EUSART_RXInterrupt(void);
	extern void EUSART_TXInterrupt(void);

#endif		// #ifdef __SIO_ENABLE__

#endif		/* __sio_hedder__ */

